/***************************************************************************
                          dcuserslist.h  -  description
                             -------------------
    begin                : Thu Nov 21 2002
    copyright            : (C) 2002 by Franois Gannaz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DCUSERSLIST_H
#define DCUSERSLIST_H

/**
  *@author Franois Gannaz
  */

#include <dclib/core/cstring.h>
#include <dclib/core/cstringlist.h>
#include <dclib/dcobject.h>

#include <DCDialogUsersList.h>

class QWorkspace;
class QListViewItem;

class DCFriendObject : public CObject {
public:
	/** */
	DCFriendObject() {
		m_pItem     = 0;
		m_eAwayMode = euamOFFLINE;
	};
	/** */
	~DCFriendObject() {};

	QListViewItem * m_pItem;

	/** */
	CString m_sName;
	/** */
	CString m_sDescription;
	/** */
	CString m_sHubName;
	/** */
	CString m_sHubHost;
	/** */
	eUserAwayMode m_eAwayMode;
};

class DCUsersList : public DCDialogUsersList {
Q_OBJECT
public:
	/** */
	DCUsersList(QWidget* parent, const char *name, int wflags);
	/** */
	virtual ~DCUsersList();

	/** */
	void InitDocument();
	/** */
	void DeInitDocument();

	/** */
	void ShowFriendsList();

	/** */
	void AddFriend( CString name, CString hubname, CString hubhost, CString description );
	/** */
	void DelFriend( CString name );
	/** */
	void UpdateFriend( CString name, CString host, CString description );

protected:
	/** */
	QWorkspace *pWorkspace;
	/** close event handler */
	virtual void closeEvent(QCloseEvent*) {};
	/** event filter */
	virtual bool eventFilter( QObject * object, QEvent * event );

private:
	/** */
	CStringList * m_pFriendList;

	/** */
	int selectedItems( QListView * list, QPtrList<QListViewItem> & lst );

private slots:
	/** */
	void slotRightButtonClickedFriendList(QListViewItem*, const QPoint &, int );
};

/** */
extern DCUsersList * pUsersList;

#endif
